#include "mawk.h"
#include "repl.h"

/* does not assume target was a cell, if so
   then caller should have made a previous
   call to cell_destroy	 */
CELL *mawk_cellcpy(mawk_state_t *MAWK, register CELL *target, register CELL *source)
{
	switch (target->type = source->type) {
	case C_NOINIT:
	case C_SPACE:
	case C_SNULL:
		break;

	case C_NUM:
		target->dval = source->dval;
		break;

	case C_STRNUM:
		target->dval = source->dval;
		/* fall thru */

	case C_REPL:
	case C_MBSTRN:
	case C_STRING:
		string(source)->ref_cnt++;
		/* fall thru */

	case C_RE:
		target->ptr = source->ptr;
		break;

	case C_REPLV:
		mawk_replv_cpy(MAWK, target, source);
		break;

	default:
		mawk_bozo(MAWK, "bad cell passed to mawk_cellcpy()");
		break;
	}
	return target;
}
